#include "stdafx.h"
#include "app.h"
#include "appDlg.h"
#include "DowComboBox.h"
#include "DemoEditBox.h"
#include "DemoSpinCtrl.h"
#include "OpaqueShoe.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif


CAppDlg::CAppDlg(CWnd* pParent)	: CDialog(CAppDlg::IDD, pParent),
                                  m_sCombo(_T("Monday")),
                                  m_sEdit(_T("Your Name")),
                                  m_sSpinEdit(_T("3")),
                                  m_Color(RGB(0, 0, 0)),
                                  m_sFontNameFace(_T("Times New Roman")),
                                  m_bBooleanValue(TRUE),
                                  m_hIcon(AfxGetApp()->LoadIcon(IDR_MAINFRAME)),
                                  m_nComboItem(-1),
                                  m_nEditItem(-1),
                                  m_nSpinCtrlItem(-1),
                                  m_nBrowseForFileItem(-1),
                                  m_nBrowseForFolderItem(-1),
                                  m_nBrowseForColorItem(-1),
                                  m_nBrowseForFont(-1),
                                  m_nFontNameComboItem(-1),
                                  m_nBooleanComboItem(-1),
                                  m_nShoeItem(-1),
                                  m_nShoeItem2(-1),
                                  m_nDateItem(-1),
                                  m_nTimeItem(-1),
                                  m_nIPAddressItem(-1),
                                  m_nFontChangingEditItem(-1),
                                  m_dwIPAddress(0),
                                  m_nComboItem2(-1)
{
  memset(&m_Font, 0, sizeof(LOGFONT));
  m_Font.lfCharSet = ANSI_CHARSET;
  _tcscpy_s(m_Font.lfFaceName, sizeof(m_Font.lfFaceName)/sizeof(TCHAR), _T("Times New Roman"));
  GetLocalTime(&m_Date);
  GetLocalTime(&m_Time);
}

void CAppDlg::DoDataExchange(CDataExchange* pDX)
{
  //Let the base class do its thing
  CDialog::DoDataExchange(pDX);

  DDX_Control(pDX, IDC_LIST1, m_ctrlListOptions);

  if (!pDX->m_bSaveAndValidate)
  {
    //Remove any items which may be in the control already
    m_ctrlListOptions.DeleteAllItems();

    //Add an edit box to the control
    m_nEditItem = m_ctrlListOptions.InsertItem(0, _T("Your First Name"), 1);
    m_ctrlListOptions.AddEditBox(m_nEditItem, RUNTIME_CLASS(CDemoEdit));

    //Add a combo box item to the control
    m_nComboItem = m_ctrlListOptions.InsertItem(1, _T("Day of the Week"), 2);
    m_ctrlListOptions.AddComboBox(m_nComboItem, RUNTIME_CLASS(CDowComboBox));

    //Add an edit box with a spin ctrl the control
    m_nSpinCtrlItem = m_ctrlListOptions.InsertItem(2, _T("Rating"), 6);
    m_ctrlListOptions.AddEditBox(m_nSpinCtrlItem, RUNTIME_CLASS(CDemoEdit), RUNTIME_CLASS(CDemoSpin));

    //Add a folder and file browser to the control
    m_nBrowseForFileItem = m_ctrlListOptions.InsertItem(3, _T("A File edit box"), 3);
    m_ctrlListOptions.AddFileEditBox(m_nBrowseForFileItem, RUNTIME_CLASS(CListOptionsEdit), RUNTIME_CLASS(CListOptionsBrowseButton));

    m_nBrowseForFolderItem = m_ctrlListOptions.InsertItem(4, _T("A Folder edit box"), 3);
    m_ctrlListOptions.AddFolderEditBox(m_nBrowseForFolderItem, RUNTIME_CLASS(CListOptionsEdit), RUNTIME_CLASS(CListOptionsBrowseButton));

    //Add a color browser to the control
    m_nBrowseForColorItem = m_ctrlListOptions.InsertItem(5, _T("A Color selector"), 5);
    m_ctrlListOptions.AddColorSelector(m_nBrowseForColorItem, RUNTIME_CLASS(CListOptionsBrowseButton));

    //Add a font browser to the control
    m_nBrowseForFont = m_ctrlListOptions.InsertItem(6, _T("A Font selector"), 4);
    m_ctrlListOptions.AddFontSelector(m_nBrowseForFont, RUNTIME_CLASS(CListOptionsBrowseButton));

    //Add a font name combo box to the control
    m_nFontNameComboItem = m_ctrlListOptions.InsertItem(7, _T("A Font Name combo"), 4);
    m_ctrlListOptions.AddComboBox(m_nFontNameComboItem, RUNTIME_CLASS(CListOptionsFontNameCombo));

    //Add a boolean combo box to the control
    m_nBooleanComboItem = m_ctrlListOptions.InsertItem(8, _T("A Boolean combo"), 0);
    m_ctrlListOptions.AddComboBox(m_nBooleanComboItem, RUNTIME_CLASS(CListOptionsBooleanCombo));

    //Add a opaque browser item example to the control
    m_nShoeItem = m_ctrlListOptions.InsertItem(9, _T("Your Shoe Size !!"), 7);
    m_ctrlListOptions.AddOpaque(m_nShoeItem, RUNTIME_CLASS(COpaqueShoeButton), NULL, 0);
    m_ctrlListOptions.SetItemText(m_nShoeItem, 1, _T("Small"));

    //Add a second example of an opaque browser item example to the control
    m_nShoeItem2 = m_ctrlListOptions.InsertItem(10, _T("Your Shoe Size (Combo)!!"), 7);
    m_ctrlListOptions.AddOpaque(m_nShoeItem2, RUNTIME_CLASS(CShoeComboBox), RUNTIME_CLASS(COpaqueShoeButton2), 0);
    m_ctrlListOptions.SetItemText(m_nShoeItem2, 1, _T("Small"));

    //Add a Date item  to the control
    m_nDateItem = m_ctrlListOptions.InsertItem(11, _T("Date example "), 9);
    m_ctrlListOptions.AddDateTime(m_nDateItem, RUNTIME_CLASS(CListOptionsDateCtrl));

    //Add a Time item  to the control
    m_nTimeItem = m_ctrlListOptions.InsertItem(12, _T("Time example "), 9);
    m_ctrlListOptions.AddDateTime(m_nTimeItem, RUNTIME_CLASS(CListOptionsTimeCtrl));

    //Add a font browser to the control
    m_nIPAddressItem = m_ctrlListOptions.InsertItem(13, _T("An IP Address selector"), 10);
    m_ctrlListOptions.AddIPAddress(m_nIPAddressItem, RUNTIME_CLASS(CListOptionsIPAddressCtrl));

    //An edit box which changes the fonts used by the control
    m_nFontChangingEditItem = m_ctrlListOptions.InsertItem(14, _T("Should cause the item fonts to change wildly"), 1);
    m_ctrlListOptions.AddEditBox(m_nFontChangingEditItem, RUNTIME_CLASS(CDemoEdit2));
    
    //Add a second combo box item to the control
    m_nComboItem2 = m_ctrlListOptions.InsertItem(15, _T("Your First Name"), 2);
    m_ctrlListOptions.AddComboBox(m_nComboItem2, RUNTIME_CLASS(CFirstNameComboBox));

    //Hook up the image list
    m_ImageList.Create(IDB_OPTIONS, 16, 1, RGB(255, 0, 255));
    m_ctrlListOptions.SetImageList(&m_ImageList, LVSIL_SMALL); 
  }

  //Try out the DDX functions
  DDX_ListEdit (pDX, IDC_LIST1, m_nEditItem, m_sEdit);
  DDX_ListCombo(pDX, IDC_LIST1, m_nComboItem, m_sCombo);
  DDX_ListEdit (pDX, IDC_LIST1, m_nSpinCtrlItem, m_sSpinEdit);
  DDX_ListColor(pDX, IDC_LIST1, m_nBrowseForColorItem, m_Color);
  DDX_ListFont (pDX, IDC_LIST1, m_nBrowseForFont, &m_Font);
  DDX_ListCombo(pDX, IDC_LIST1, m_nFontNameComboItem, m_sFontNameFace);
  DDX_ListBoolean(pDX, IDC_LIST1, m_nBooleanComboItem, m_bBooleanValue);
  DDX_ListDateTime(pDX, IDC_LIST1, m_nDateItem, m_Date);
  DDX_ListDateTime(pDX, IDC_LIST1, m_nTimeItem, m_Time);
  DDX_ListIPAddress(pDX, IDC_LIST1, m_nIPAddressItem, m_dwIPAddress);
}

BEGIN_MESSAGE_MAP(CAppDlg, CDialog)
  ON_WM_PAINT()
  ON_WM_QUERYDRAGICON()
END_MESSAGE_MAP()

BOOL CAppDlg::OnInitDialog()
{
  //Let the parent do its thing
  CDialog::OnInitDialog();

  //Setup the dialog icons
  SetIcon(m_hIcon, TRUE);
  SetIcon(m_hIcon, FALSE);

  return TRUE;
}

void CAppDlg::OnPaint() 
{
  if (IsIconic())
  {
    CPaintDC dc(this); //device context for painting

    SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

    //Center icon in client rectangle
    int cxIcon = GetSystemMetrics(SM_CXICON);
    int cyIcon = GetSystemMetrics(SM_CYICON);
    CRect rect;
    GetClientRect(&rect);
    int x = (rect.Width() - cxIcon + 1) / 2;
    int y = (rect.Height() - cyIcon + 1) / 2;

    //Draw the icon
    dc.DrawIcon(x, y, m_hIcon);
  }
  else
  {
    CDialog::OnPaint();
  }
}

HCURSOR CAppDlg::OnQueryDragIcon()
{
  return static_cast<HCURSOR>(m_hIcon);
}

